#include <iostream>
#include <sstream>

#include "Data.h"


Data::Data()
{
    delimiter = ',';
}

Data::Data(string _date, double _adj_close, long _volume)
{
    setDate(_date);
    setAdjClose(_adj_close);
    setVolume(_volume);
}

string Data::getDate() const
{
    return date;
}

double Data::getAdjClose() const
{
    return adj_close;
}

long Data::getVolume() const
{
    return volume;
}

void Data::setDate(string _date)
{
    char sep;
    date = _date;
    // parse mm/dd/yyyy 
    stringstream ss(date);
    ss >> _month >> sep >> _day >> sep >> _year;
}

void Data::setAdjClose(double _adj_close)
{
    adj_close = _adj_close;
}

void Data::setVolume(long _volume)
{
    volume = _volume;
}

bool operator==(const Data& lhs, const Data& rhs)
{
    if (lhs.getDate() != rhs.getDate())
        return false;
        
    if (lhs.getAdjClose() != rhs.getAdjClose())
        return false;
        
    if (lhs.getVolume() != rhs.getVolume())
        return false;
    
    return true;
}

bool operator< (const Data& lhs, const Data& rhs)
{
    if (lhs._year < rhs._year)
        return true;
    
    if (lhs._year == rhs._year)
    {
        if (lhs._month < rhs._month)
            return true;
        
        if (lhs._month == rhs._month)
            return lhs._day < rhs._day;
        
    } 
    
    return false;
}

bool operator> (const Data& lhs, const Data& rhs)
{
    if (lhs._year > rhs._year)
        return true;
    
    if (lhs._year == rhs._year)
    {
        if (lhs._month > rhs._month)
            return true;
        
        if (lhs._month == rhs._month)
            return lhs._day > rhs._day;
        
    } 
    
    return false;
}

ostream& operator<<(ostream& os, const Data& d)
{
    os << d.getDate() << d.delimiter << d.getAdjClose() << d.delimiter << d.getVolume();
    return os;
} 

istream& operator>>(istream& is, Data& d)
{
    char sep;
    string line;
    string _date;
    double _adj_close;
    long _volume;

    getline(is, line);
    stringstream ss(line);
    
    getline(ss, _date, d.delimiter);
    ss >> _adj_close >> sep >> _volume;

    d.setDate(_date);
    d.setAdjClose(_adj_close);
    d.setVolume(_volume);

    return is;
}
