#include <iostream>
#include <fstream>
#include <vector>

#include "DataContainer.h"


int main(int argc, char **argv)
{
    vector<string> symbols;
    vector<DataContainer> collection;
    DataContainer dataObj;

    int firstTop, confirmation;

    string symbol, filename;
    //string filename_prefix("../Projects/final_project/data_files/");

    ifstream namesFile("names.csv");
    while (namesFile >> symbol)
    {
        filename = symbol + ".csv";
        cout << filename << endl;
        ifstream infile(filename.c_str());
        if (infile.good())
        {
            infile >> dataObj;
            collection.push_back(dataObj);
            symbols.push_back(symbol);
            infile.close();
        }
    }
    namesFile.close();
    
    
    ofstream statusFile("status.csv");
    statusFile << "symbol,YES/NO" << endl; // write header
    for (int j = 0; j < collection.size(); ++j)
    {
        vector<DataContainer>::const_iterator it = collection.begin() + j;
        bool hasDoubleTop = it->doubleTop(firstTop, confirmation);
        
        statusFile << symbols[j] << "," << (hasDoubleTop ? "YES" : "NO") << endl;
        
        if (hasDoubleTop)
        {
            DataContainer finalData;
            finalData.setHeader(it->getHeader());
            for (int i = firstTop; i <= confirmation; i++)
                finalData.addData(it->getData(i));
            
            filename = symbols[j] + "-final.csv";

            ofstream outfile(filename.c_str());
            outfile << finalData;
            outfile.close();
        }
    }
    statusFile.close();

    return 0;
}
